/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test;

import java.io.IOException;
import java.io.PrintWriter;
import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author mvelik
 */
public class StoryServlet extends HttpServlet
{
    @EJB(beanName="Unwritten")
    private ResourceInjectionTrialLocal processorDriver0;
    @EJB(beanName="Pinnochio")
    private ResourceInjectionTrialLocal processorDriver1;
    @EJB(beanName="Dumbo")
    private ResourceInjectionTrialLocal processorDriver2;

    protected void tellStory(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
        response.setContentType("text/html;charset=UTF-8");

        PrintWriter out = response.getWriter();

        ResourceInjectionTrialLocal[] processors =
        {
            processorDriver0, processorDriver1,
            processorDriver2
        };
        try
        {

            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet Test for Resource Injection Trial</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet StoryServlet at " + request.getContextPath() + "</h1>");
            for (int i = 0; i < processors.length; i++)
            {
                if (processors[i] != null)
                {
                    generateOutput(processors[i], out);
                }
            }

            out.println("</body>");
            out.println("</html>");

        }
        finally
        {
            out.close();
        }

    }

    @Override
    protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1) throws ServletException, IOException
    {
        this.tellStory(arg0, arg1);
    }

    @Override
    protected void doPost(HttpServletRequest arg0, HttpServletResponse arg1) throws ServletException, IOException
    {
        this.tellStory(arg0, arg1);
    }

    private void generateOutput(ResourceInjectionTrialLocal processor, PrintWriter out)
    {
        StringBuffer scroll = new StringBuffer();
        System.out.println("~");
        System.out.println("~");
        System.out.println("~~~~~ Start ResourceInjectionTrialBean tellStory method call for " + processor.tellName() + " ~~~~~");
        processor.tellStory(scroll);
        System.out.println("~~~~~ End ResourceInjectionTrialBean tellStory method call for " + processor.tellName() + " ~~~~~");
        System.out.println(scroll.toString());

        System.out.println("~~~ End of Story ~~~");
        System.out.println("~");



        out.println("<h3>ResourceInjectionTrialBean " + processor.tellName() + " tellStory(StringBuffer buff) result</h1>");
        out.println("<p>");
        out.println(scroll.toString());
        out.println("</p>");

    }
}
